/* shmprod.c */

/* adapted from C. Santoro */

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/shm.h>

#include "prodcons.h"


int sem_id;		// set of semaphores/condvars PRODUCED, CONSUMED
int shm_id;		// id of buffer shared by prod/cons

char * buffer;

void get_resources(void)
{
  sem_id = semget(SEMKEY, 2 , 0);
  if (sem_id < 0) {
    perror("Getting semaphores/condvars");
    exit(1);
  }
  shm_id = shmget(SHMKEY, 10 , 0);
  if (shm_id < 0) {
    perror("getting shared buffer");
    exit(1);
  }
  buffer = (char *)shmat(shm_id,0,0);
}


int main(int argc,char *argv[])
{
  int i;

  get_resources();
  for (;;) {
    WAIT(PRODUCED);
    printf("From buffer<<< ");
    for (i = 0;i < 10;i++)
      putchar(buffer[i]);
    putchar('\n');
    sleep(1);
    SIGNAL(CONSUMED);
  }
}