/* shmprod.c */

/* adapted from C. Santoro */

#include <stdio.h>
#include <unistd.h>
#include <signal.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/shm.h>

#include "prodcons.h"


int sem_id, shm_id;

char * pvar;

char * buffer;

int test;

void cleanup(int sig)
{
  shmdt(buffer);
  semctl(sem_id, 0, IPC_RMID, 0);
  shmctl(shm_id, IPC_RMID, 0);
  exit(1);
}

void init_resources(void)
{
  sem_id = semget(SEMKEY, 2 , IPC_CREAT | PERMS);
  if (sem_id < 0) {
    perror("creating semaphores/condvars");
    exit(1);
  }
  shm_id = shmget(SHMKEY, 8192 , IPC_CREAT | PERMS);
  if (shm_id < 0) {
    perror("creating shared buffer");
    semctl(sem_id, 0, IPC_RMID, 0);		// cleanup semaphores
    exit(1);
  }
  buffer = (char *) shmat(shm_id, (char *) 10000, SHM_RND);   
  if ((int) buffer == -1) {
  	perror("attaching");
  	exit(-1);
  }
 
  signal(SIGINT,cleanup);
  signal(SIGQUIT,cleanup);
  signal(SIGHUP,cleanup);
}

int main(int argc,char *argv[])
{
  int c, i;

  init_resources();
  for (c = 'A'; ;) {
    memset(buffer,c,10);
    printf("To buffer>>> ");
    for (i = 0; i < 10; i++)
      putchar(buffer[i]);
    putchar('\n');
    SIGNAL(PRODUCED);
    WAIT(CONSUMED);
    if (++c > 127)  c = 32;
  }
}